/*
   Version 1.0
   This firmware is developed for evive Scratch Extension [http://evive.cc].
   This is licensed under GNU GPL V3 [http://www.gnu.org/licenses/gpl.txt].
   Written by Pankaj Verma and Ayush Shakya for evive platform, Agilo Research.
   Last update: 2017, August 15, by Pankaj Verma
   Contact: support@evive.cc
   Copyright (c) 2017 Agilo Research.  All rights reserved.

   Getting started with evive: http://evive.cc/learn

   NOTE: Works with Arduino IDE 1.6.6 or later [https://www.arduino.cc/en/Main/Software]
*/

//*************************************************************************
//      ff 55 len idx action device port slot data a
//      0  1  2   3   4      5      6    7    8
//*************************************************************************
#ifndef EVIVESCRATCHFIRMWARE_H
#define EVIVESCRATCHFIRMWARE_H

#include <Wire.h>
#include <SoftwareSerial.h>
#include <Arduino.h>
#include "evive.h"
#include "DHT.h"
#include "Rtc_Pcf8563.h"
#include "MFRC522.h"
#include "Keypad.h"

// Device IDs
#define RGBLED 8
#define SERVO 11
#define DIGITAL 30
#define ANALOG 31
#define PWM 32
#define SERVO_PIN 33
#define TONE 34
#define PULSEIN 37
#define ULTRASONIC_ARDUINO 36
#define TIMER 50
#define IROBSTACLE 52
#define DHTH 42
#define DHTT 43
#define TOUCH 44
#define NAVKEY 45
#define TIME 46
#define DATE 47
#define ROTENC 53
#define ENCPOS 54
#define ENCDIR 55
#define SETRFID 56
#define GETRFID 57
#define KEYPAD 58
#define RUNMOTORA 10
#define RUNMOTORB 9
#define STEPPER 12
#define TFTWRITE 13
#define FILLSCREEN 14
#define SETCURSOR 15
#define SETTEXTCOLOR 16
#define SETTEXTSIZE 17
#define DRAWLINE 18
#define DRAWVLINE 19
#define DRAWHLINE 20
#define FILLRECTANGLE 21
#define FILLROUNDRECTANGLE 22
#define FILLCIRCLE 23
#define FILLELLIPSE 24
#define FILLTRIANGLE 25
#define DRAWRECTANGLE 26
#define DRAWROUNDRECTANGLE 27
#define DRAWCIRCLE 28
#define DRAWELLIPSE 29
#define DRAWTRIANGLE 60
#define INITTFT 61

#define GET 1
#define RUN 2
#define RESET 4
#define START 5

void eviveScratchFirmwareSetup();

void eviveScratchFirmwareLoop();

unsigned char readBuffer(int index);
void writeBuffer(int index, unsigned char c);
void writeHead();
void writeEnd();
void writeSerial(unsigned char c);
void readSerial();
void parseData();
void callOK();
void sendByte(char c);
void sendString(String s);
void sendFloat(float value);
void sendShort(double value);
void sendDouble(double value);
short readShort(int idx);
float readFloat(int idx);
long readLong(int idx);
void runModule(int device);
int searchServoPin(int pin);
void readSensor(int device);

#endif